unit ImageEnTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.ImageList, ievision, imageenview, iexBitmaps,
  iesettings, iexLayers, hyiedefs, hyieutils, iexRulers, Vcl.ImgList, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TReadCodeData = record
    kandidatValue: string;
    stranValue: string;
    qrValue: String;
    qrPosition: TRect;
    StatusDekodiranja: string;
  end;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    OpenDialog1: TOpenDialog;
    ButtonedEdit1: TButtonedEdit;
    ImageList1: TImageList;
    Label1: TLabel;
    Memo1: TMemo;
    procedure ButtonedEdit1RightButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure ReadBarcodeFromFile(FileName: string);
    { Private declarations }
  public
    FFileName: string;
    { Public declarations }
  end;

CONST
  IEVISION_DLLPath = '.\ievision.dll';

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ButtonedEdit1RightButtonClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Memo1.Clear;
    ButtonedEdit1.Text := OpenDialog1.FileName;
    FFileName := OpenDialog1.FileName;
    ReadBarcodeFromFile(FFileName);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // VER 6.0:
  IEVisionSetSerialNumber('matjaz.urank@ric.si', 'ievis-bab92e83-620ba536-35666d48-dc6b57ab');

//  IEInitialize_ievision(IEVISION_DLLPath, False); // Initialize DLL in custom location

  if not IEVisionAvailable() then
  begin
    ShowMessage('This application requires the ievision.dll plug-in, v' + IEVC_EXPECTED_LIBRARY_VERSION +
      '. Please download it from www.imageen.com');
    Application.Terminate;
    exit;
  end;
end;

procedure TForm1.ReadBarcodeFromFile(FileName: string);
var
  symbols: TIEVisionVectorObjRef;
  IEBitmap: TIEBitmap;
  Img: TIEVisionImage;
  s: TIEVisionBarCodeSymbol;
  i: integer;
  barCodeValue: String;
  barCodeI2of5Found : Boolean;
  x1k, x4k, y1k, y4k: integer;

begin
  barCodeI2of5Found:= False;

  try
    IEBitmap := TIEBitmap.Create(FileName);
    Img := IEBitmap.GetIEVisionImage();

    symbols := IEVisionLib.createBarCodeScanner().Scan(Img, IEVisionRect(0, 0, 0, 0));
    if symbols.size() > 0 then
    begin
      for i := 0 to symbols.size() - 1 do
      begin
        s := TIEVisionBarCodeSymbol(symbols.getObj(i));

        if s.getSymbolType().c_str() = 'I2/5' then
        begin
          barCodeI2of5Found:= True;

          barCodeValue := trim(s.getData().c_str());

          Memo1.Lines.Add('Barcode I2/5 value: ' + barCodeValue);

          x1k := s.getBoundingBox.x;
          x4k := s.getBoundingBox.x + s.getBoundingBox.width;
          y1k := s.getBoundingBox.y;
          y4k := s.getBoundingBox.y + s.getBoundingBox.height;

          Memo1.Lines.Add('Barcode position: ');
          Memo1.Lines.Add('x1: ' + inttostr(x1k));
          Memo1.Lines.Add('x4: ' + inttostr(x4k));
          Memo1.Lines.Add('y1: ' + inttostr(y1k));
          Memo1.Lines.Add('y4: ' + inttostr(y4k));
        end;
      end;

      if not barCodeI2of5Found then
        Memo1.Lines.Add('No barcode found' + barCodeValue);

    end
  finally
    IEBitmap.Free;
  end;
end;

end.
